//--------------------------------------//
// MoreBlood  2010 - Mr.Loathsome       //
// Players bleed where they take damage //
// Based on the Bleeder mutator         //
//--------------------------------------//
class MB expands Mutator;

var bool Initialized;

function PostBeginPlay()
{
	if (Initialized) return;
	else Initialized = True;
	Level.Game.RegisterDamageMutator(Self);
	Super.PostBeginPlay();
}

function MutatorTakeDamage(out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType)
{
	local BleederEffectSpawner BES;
	local class<Effects> EffS;
	local int i, j;

	if (ActualDamage > 0)
	{
	if ((Victim.Health - ActualDamage) <= 0 )
		{
		if ( (damagetype!='gibbed') && (!Victim.gibbed(damagetype)) 
		     && (damagetype!='icestatued')
		     && (damagetype!='Disrupted')
		     && (damagetype!='stoned') 
		     && (damagetype!='Burned')
		     && (damagetype!='Napalmed')
		     &&	((ActualDamage < 50) && (Victim.bIsPlayer)))
			DeathEffect(ActualDamage, Victim);
		}
		else
			if ((Victim.health - ActualDamage) <= Victim.default.health)
				{
				BES = Spawn(class'BleederEffectSpawner', Victim, , HitLocation, Victim.Rotation);
				if (BES != None)
				{
					j = ActualDamage;
					if (j <= 100)
						j = j * 3;
					else j = 200;
					BES.InitSpawner();
					if ((Victim.IsA('ScriptedPawn')) && (ScriptedPawn(Victim).bGreenBlood))
					{
						if (ActualDamage < 15)
						{
							EffS = class'UTB_GBloodDrop';
							j = j*10;
						}
						else
						if (ActualDamage < 25)
						{
							if (Rand(2) == 1)
								EffS = class'GreenBlob';
							else
								EffS = class'GreenBloodSpray';
						}
						else
						if (ActualDamage < 40)
						{
							EffS = class'UT_GreenBloodPuff';
						}
						else
						if (ActualDamage < 55)
							EffS = class'GreenBloodPuff';
						else
							EffS = class'GreenBloodSpray';
					}
					else
					{
						if (ActualDamage < 15)
						{
							EffS = class'UTB_BloodDrop';
							j = j*15;
						}
						else
						if (ActualDamage < 25)
						{
							if (Rand(2) == 1)
								EffS = class'UT_BloodHit';
							else
								EffS = class'BloodSpurt';
						}
						else
						if (ActualDamage < 40)
						{
							if (Rand(2) == 1)
								EffS = class'UTB_BloodDrop';
							else
								EffS = class'BloodPuff';
						}
						else
						if (ActualDamage < 60)
						{
							EffS = class'UT_BigBloodHit';
						}
						else
							EffS = class'BloodSpray';
					}
					BES.SetSpawnProperties(0.5, j, j, EffS, true);
					BES = None;
				}
			}
	}
	Super.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);
}

simulated function DeathEffect(int ActualDamage, Pawn Other)
{
	local BleederEffectSpawner BES;
	local class<Effects> EffS;
	local vector tmpv;

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'GreenBloodSpray';
	BES.SetSpawnProperties(0.5, 4, 4, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'GreenBloodPuff';
	BES.SetSpawnProperties(0.5, 1, 1, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'GreenGelPuff';
	BES.SetSpawnProperties(0.5, 1, 1, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_BloodDrop';
	BES.SetSpawnProperties(0.5, 60, 60, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'BloodSpurt';
	BES.SetSpawnProperties(0.5, 30, 30, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_GBloodDrop';
	BES.SetSpawnProperties(0.5, 5, 5, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'BloodSpray';
	BES.SetSpawnProperties(0.5, 25, 25, EffS, true);

	if (ActualDamage < 40)
	{
		tmpv = Other.Location - vect(0,0,38);
		BES = Spawn(class'BleederEffectSpawner', Other, , tmpv, );
		BES.InitSpawner();
		EffS = class'UTB_BloodTrail';
		BES.SetSpawnProperties(0.5, 2, 2, EffS, true);

		tmpv = Other.Location - vect(0,0,40);
		BES = Spawn(class'BleederEffectSpawner', Other, , tmpv, );
		BES.InitSpawner();
		EffS = class'UTB_BloodPool';
		BES.SetSpawnProperties(0.5, 1, 1, EffS, true);
	}
}

defaultproperties
{
     bHidden=True
}
